﻿Imports System.IO

Public Class Form1

    Dim nomes1() As String
    Dim nomes2() As String

    Private Sub btnLerNomes1_Click(sender As Object, e As EventArgs) Handles btnLerNomes1.Click

        Dim origem As String = "c:\dados\nomes1.csv"
        If File.Exists(origem) Then
            nomes1 = File.ReadAllLines(origem)
            lbNomes1.Items.AddRange(nomes1)
            btnLerNomes2.Enabled = True
        Else
            MessageBox.Show("O arquivo não existe.", "Não Existe")
        End If
    End Sub


    Private Sub btnLerNomes2_Click(sender As Object, e As EventArgs) Handles btnLerNomes2.Click
        Dim origem As String = "c:\dados\nomes2.csv"
        If File.Exists(origem) Then
            nomes2 = File.ReadAllLines(origem)
            lbNomes2.Items.AddRange(nomes1)
            btnMesclarOrganizar.Enabled = True
        Else
            MessageBox.Show("O arquivo não existe.", "Não Existe")
        End If
    End Sub

    Private Sub btnMesclarOrganizar_Click(sender As Object, e As EventArgs) Handles btnMesclarOrganizar.Click

        ' Concatena e remove nomes duplicados
        Dim consultaMesclaArquivos As IEnumerable(Of String) = nomes1.Union(nomes2)

        ' Agrupa os nomes pela primeira leitra no sobrenome
        Dim consultaAgruparNomes = From nome In consultaMesclaArquivos
                                   Let n = nome.Split(New Char() {","})
                                   Order By n(0)
                                   Group By chaveGrupo = n(0)(0)
                                   Into nomeGrupo = Group

        ' Cria um novo arquivo para cada grupo que foi criado
        ' Note que os laços foreach aninhados são requeridos para acessar
        ' os itens individuais de cada grupo
        For Each gGrupo In consultaAgruparNomes
            Dim nomeArquivo As String = "ArquivoTeste_" & gGrupo.chaveGrupo & ".txt"
            Dim sw As New StreamWriter(nomeArquivo)

            lbDados.Items.Add(gGrupo.chaveGrupo)

            For Each item In gGrupo.nomeGrupo
                lbDados.Items.Add("   " & item.nome)
                sw.WriteLine(item.nome)
            Next
            sw.Close()
        Next

    End Sub
End Class
